import java.io.File;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by thook on 10/7/15.
 */
public class HamletParser {

    private String hamletData;

    public HamletParser(){
        this.hamletData = loadFile();
    }

    public static String findHamlet(String book) {
        Pattern p = Pattern.compile("Hamlet");
        Matcher m = p.matcher(book);

        String str = null;
        if (m.find()){
            str = m.group();

        }else{
            return null;
        }
        return str;

    }

    public static String findHoratio(String book) {

        Pattern p = Pattern.compile("[HoratioHORATIO]");
        Matcher m = p.matcher(book);

        String str;

        if(m.find()){
            str = m.group();
        } else {
            return null;
        }
        return str;
    }

    public static String changeToLeon(String book) {
        Pattern p = Pattern.compile(book);
        Matcher m = p.matcher(book.toLowerCase());

        book = m.replaceAll("leon");

        return book;
    }

    public static String changeToTariq(String book) {
        Pattern p = Pattern.compile(book);
        Matcher m = p.matcher(book.toLowerCase());

        book = m.replaceAll("tariq");

        return book;
    }

    private String loadFile(){
        ClassLoader classLoader = getClass().getClassLoader();
        File file = new File(classLoader.getResource("hamlet.txt").getFile());
        StringBuilder result = new StringBuilder("");

        try(Scanner scanner = new Scanner(file)){
            while(scanner.hasNextLine()){
                String line = scanner.nextLine();
                result.append(line).append("\n");
            }

            scanner.close();
        }catch(IOException e){
            e.printStackTrace();
        }

        return result.toString();
    }

    public String getHamletData(){
        return hamletData;
    }

}
